/****************************************
 * Conversion Midi vers DMX
 * Interface-Z
 * Actuators Midi to DMX
 *****************************************/

// Importer la library the Midibus
// http://smallbutdigital.com/themidibus.php
import themidibus.*; 

MidiBus myBus; 

int consignedmx;
int compteur = 0;
int valeurmidi, numeromidi, numerodmx, canalmidi;

PFont policeperso;

void setup()
{
  size(220, 340);
  noStroke();
  smooth();

  // Liste des peripheriques Midi disponibles sur l'ordinateur
  // Displaying Midi devices existing on the computer  
  MidiBus.list(); 

  // Ouverture de port (this, In, Out)
  // Choisir le numero du peripherique dans la liste
  // In et Out etant les numeros des peripheriques entrant et sortant
  // Open Midi port (this, In, Out)
  // Choose the appropriate Midi device from the list
  // In and Out being the corresponding In and Out devices
  myBus = new MidiBus(this, -1, 3);
  // -1 pour ne pas ouvrir ce port
  // -1 in order not to open this port

  policeperso = loadFont("Arial-Black-32.vlw");
  textFont(policeperso, 32);
}

void draw()
{
  background(0);
  numerodmx = 0;
  compteur = (compteur + 1) % 256;
  // Envoie de commandes graduelles en boucle 
  // en decalage sur 4 canaux DMX.
  // Sending values on 4 DMX channels.
  // La carte doit etre configuree sur le premier canal Midi
  consignedmx = compteur;
  if (consignedmx<0) {
    consignedmx = 0;
  }
  if (consignedmx>255) {
    consignedmx = 255;
  }
  if (consignedmx<128) {
    valeurmidi = consignedmx;
    numeromidi = (numerodmx * 2) % 128;
    canalmidi = ((numerodmx % 512)/64);
  }
  if (consignedmx>=128) {
    valeurmidi = consignedmx - 128;
    numeromidi = ((numerodmx * 2) + 1) % 128;
    canalmidi = ((numerodmx % 512)/64);
  }
  //les canaux midi commandencent a 0.
  myBus.sendControllerChange(canalmidi, numeromidi, valeurmidi);
  println(valeurmidi);
  println(numeromidi);
  println(canalmidi);
  textFont(policeperso, 32);

  fill(255);
  text("Midi", 50, 70);
  text("vers", 70, 100);
  text("DMX", 90, 130);
  text("256 pas", 50, 180);

  // Representation des consignes envoyees sur des sliders.
  // Displaying sent values on sliders.
  fill(30, 200, 30, 200);
  rect(20, 40, 20, 256);
  fill(130, 240, 130, 200);
  rect(20, 40+255-consignedmx, 20, consignedmx);
  text(consignedmx, 50, 250);

  textFont(policeperso, 16);
  fill(255);
  text("Interface-Z", 90, 295);
}

